#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <asm/io.h>

int main(int argc,char *argv[]){
  int port,data,i;

  if(argc>4) return -1;
  if(argc<2) return -1;

  if(*argv[1]=='r'){
    if(argc!=3) return -1;
    sscanf(argv[2],"%X",&port);
    if(ioperm(port,2,1)){
      fprintf(stderr,"I/O Port Error, Check port I/O address %X.\n",port);
      return -1;
    }
    else{
      data=inw(port);
      /*printf("IO port %X Read data[hex]=0x%04X\n",port,data);*/
      printf("%d\n",data);
      return 0;
    }
  }
  else if(*argv[1]=='w'){
    if(argc!=4) return -1;
    sscanf(argv[2],"%X",&port);
    sscanf(argv[3],"%X",&data);    
    if(ioperm(port,2,1)){
      fprintf(stderr,"I/O Port Error, Check port I/O address.\n");
      return -1;
    }
    else{
      outw(data,port);
      /*printf("IO port %X write data[hex]=0x%04X\n",port,data);*/
      return 0;
    }
  }
  else{
    printf("First argument must be 'r' or 'w'.\n");
    return -1;
  }
  return 0;
}



